(function () {
    global.dashModule
        .controller('bidsCtrl', ['$scope', bidsController])
        .directive('bids', [bidsDirective]);

    function bidsDirective() {
        return {
            restrict: 'E',
            templateUrl: 'bids/html/bidsTemplate'
        };
    }

    function bidsController($scope) {
        $scope.isSubmoduleVisible = isSubmoduleVisible;
        $scope.setSubModule = setSubModule;
        $scope.subModule = global.getParameterByName('subModule') || 'bidsView';
        addUrlListener();

        function addUrlListener() {
            window.addEventListener('popstate', function (e) {
                $scope.$evalAsync($scope => {
                    $scope.subModule = e.state ? e.state.subModule : 'bidsView';
                });
            }, false);
        }

        function setSubModule($event) {
            $scope.subModule = $event.currentTarget.attributes.subModule.value;
            history.pushState({
                subModule: $scope.subModule
            }, null, '?subModule=' + $scope.subModule);
        }

        function isSubmoduleVisible(subModule) {
            return subModule === $scope.subModule;
        }
    }
})();
